
/* Copyright (c) 2007, 2008 Thorsten Kukuk
   Author: Thorsten Kukuk <kukuk@suse.de>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>

int
main (int argc, char *argv[])
{
  FILE *fp;

  if (argc != 1)
    {
      fprintf (stderr, "Usage: html2yast < input  > output\n");
      return 1;
    }


  fp = stdin; /* fopen (argv[1], "r"); */

  while (!feof (fp))
    {
      int c;

      c = fgetc (fp);
      if (feof (fp)) /* Ignore c == EOF */
	break;

      if (c == '<')
	{
	  int c1, c2;

	  c1 = fgetc (fp);

	  switch (c1)
	    {
	    case '/':
	      c2 = fgetc (fp);
	      if (c2 == 'a')
		{
		  /* '</a>' */
		  while (c2 != '>')
		    c2 = fgetc (fp);
		}
	      else
		{
		  fprintf (stdout, "%c%c%c", c, c1, c2);
		}
	      break;
	    case 'a':
	      c2 = fgetc (fp);

	      if (c2 == ' ') /* '<a ...>' */
		{
		  while (c2 != '>')
		    c2 = fgetc (fp);
		}
	      else
		fprintf (stdout, "%c%c%c", c, c1, c2);
	      break;
	    default:
	      fputc (c, stdout);
	      fputc (c1, stdout);
	      break;
	    }
	}
      else
	fputc (c, stdout);
    }

  return 0;
}
