# BranchServer configuration logic for SLEPOS-GUI
package POS::Admin::GUI::BS;

use warnings;
use strict;
# GUI common, includes yui
use base 'POS::Admin::GUI';
our @ISA = qw(POS::Admin::GUI);
# Data interface
use POS::Admin::GUI::Data;

our $VERSION = 0.1;

my %objects = (
    EDIT_ORG         => { LABEL => 'Organi&zation o=',                    VALUE => undef, WIDGET => undef },
    EDIT_C           => { LABEL => 'Countr&y c=',                         VALUE => undef, WIDGET => undef },
    EDIT_OU          => { LABEL => 'Organizational &Unit ou=',            VALUE => undef, WIDGET => undef },
    EDIT_LOC         => { LABEL => '&Location cn=',                       VALUE => undef, WIDGET => undef },
    EDIT_HOST        => { LABEL => 'BranchServer &hostname',              VALUE => undef, WIDGET => undef },
    EDIT_NET         => { LABEL => 'BranchServer net&work address',       VALUE => undef, WIDGET => undef },
    EDIT_NET_MASK    => { LABEL => 'BranchServer network mask',           VALUE => undef, WIDGET => undef },
    EDIT_PASS        => { LABEL => 'BranchServer access &password',       VALUE => undef, WIDGET => undef },
    EDIT_PASS2       => { LABEL => 'Retype BranchServer password', },
    EDIT_IP_MAP      => { LABEL => 'IP m&apping function',                VALUE => undef, WIDGET => undef },
    EDIT_DNS_MAP     => { LABEL => 'DNS &mapping function',               VALUE => undef, WIDGET => undef },
    EDIT_GATEWAY     => { LABEL => 'BranchServer default gateway',        VALUE => undef, WIDGET => undef },
    EDIT_ENUMMASK    => { LABEL => 'Enumeration mask',                    VALUE => undef, WIDGET => undef },
    EDIT_WSBASE      => { LABEL => 'Workstation base name',               VALUE => undef, WIDGET => undef },
    EDIT_ASSOCDOMAIN => { LABEL => 'Associated domain',                   VALUE => undef, WIDGET => undef },
    EDIT_CONTAINER   => { LABEL => 'Server container' },
    CHCK_LROLES      => { LABEL => 'Use roles',                           VALUE => undef, WIDGET => undef },
    CHCK_GROLES      => { LABEL => 'Use &global roles',                   VALUE => undef, WIDGET => undef },
    CHCK_EXDHCP      => { LABEL => 'Use e&xternal DHCP',                  VALUE => undef, WIDGET => undef },
    BTN_NOU          => { LABEL => 'Add nes&ted OU',                      VALUE => undef, WIDGET => undef },
    BTN_ADV          => { LABEL => 'BranchServer services configuration', VALUE => undef, WIDGET => undef },
    BTN_NET          => { LABEL => 'BranchServer network configuration',  VALUE => undef, WIDGET => undef },
    BTN_ROLES        => { LABEL => 'Roles configuration',                 VALUE => undef, WIDGET => undef },
    BTN_NEW          => { LABEL => 'Add/update BranchServer',             VALUE => undef, WIDGET => undef },
    BTN_DELETE       => { LABEL => 'Remove BranchServer',                 VALUE => undef, WIDGET => undef },
    BTN_SAVE         => { LABEL => 'Return to BS configuration',          VALUE => undef, WIDGET => undef },
    GLOBAL           => { LABEL => 'BranchServer configuration',          VALUE => undef, WIDGET => undef },
    DETAILS          => { LABEL => 'BranchServer details',                VALUE => undef, WIDGET => undef },
    ADVANCED         => { LABEL => 'BranchServer advanced configuration', VALUE => undef, WIDGET => undef },
    ## network
    EDIT_NIC_IPADDR  => { LABEL => 'NIC ip address',               VALUE  => undef, WIDGET => undef },
    EDIT_NIC_NAME    => { LABEL => 'NIC device name',              VALUE  => undef, WIDGET => undef },
    FRAME_NETDETAILS => { LABEL => 'BranchServer network details', VALUE  => undef, WIDGET => undef },
    FRAME_NETNICS    => { LABEL => 'BranchServer network cards',   VALUE  => undef, WIDGET => undef },
    SEL_NICS         => { LABEL => 'BranchServer Network cards',   VALUE  => undef, WIDGET => undef },
    SEL_NICS_NEW     => { LABEL => '<add new network card>',       VALUE  => undef, WIDGET => undef },
    BTN_NIC_ADD      => { LABEL => 'Add device',                   LABEL1 => 'Update device' },
    BTN_NIC_DEL      => { LABEL => 'Delete device',                VALUE  => undef, WIDGET => undef },
    ## services
    EDIT_DHCP            => { LABEL => 'DHCP dynamic IP range',                  VALUE => undef, WIDGET => undef },
    EDIT_DHCP_FIXED      => { LABEL => 'DHCP fixed IP range',                    VALUE => undef, WIDGET => undef },
    EDIT_SERVICE_NAME    => { LABEL => 'Service name',                           VALUE => undef, WIDGET => undef },
    EDIT_SERVICE_DNS     => { LABEL => 'Service DNS name',                       VALUE => undef, WIDGET => undef },
    EDIT_SERVICE_SCRIPT  => { LABEL => 'Name of service script in /etc/init.d/', VALUE => undef, WIDGET => undef },
    EDIT_SERVICE_PARAMS  => { LABEL => 'Service specific parameters',            VALUE => undef, WIDGET => undef },
    CHCK_SERVICE_ENABLED => { LABEL => 'Service enabled',                        VALUE => undef, WIDGET => undef },
    FRAME_SERVICE        => { LABEL => 'BranchServer services configuration',    VALUE => undef, WIDGET => undef },
    BTN_SERVICE_ADD => { LABEL => 'Add service',                 LABEL1 => 'Update service' },
    BTN_SERVICE_DEL => { LABEL => 'Delete service',              VALUE  => undef, WIDGET => undef },
    SEL_SERVICE     => { LABEL => 'List of registered services', VALUE  => undef, WIDGET => undef },
    SEL_SERVICE_NEW => { LABEL => '<add new service>',           VALUE  => undef, WIDGET => undef },
    ## roles
    FRAME_ROLES       => { LABEL => 'Role configuration',       VALUE => undef, WIDGET => undef },
    SEL_ROLES         => { LABEL => 'List of registered roles', VALUE => undef, WIDGET => undef },
    SEL_ROLES_NEW     => { LABEL => '<add new role>',           VALUE => undef, WIDGET => undef },
    RADIO_ROLE_GLOBAL => { LABEL => 'Global role',              VALUE => undef, WIDGET => undef },
    RADIO_ROLE_LOCAL  => { LABEL => 'Local role',               VALUE => undef, WIDGET => undef },
    EDIT_ROLE_NAME    => { LABEL => 'Role name',                VALUE => undef, WIDGET => undef },
    EDIT_IDLIST       => { LABEL => 'List of allowed IDs separated by ;' },
    BTN_ROLE_ADD => { LABEL => 'Add role',    LABEL1 => 'Update role' },
    BTN_ROLE_DEL => { LABEL => 'Remove role', VALUE  => undef, WIDGET => undef },
);

my $editDNValidChars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-';
my $editCValidChars  = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';

## other strings
my $serviceNameAlreadyExists = 'Service with this name already exists. Cannot rename';
my $nicNameAlreadyExists     = 'Network device with this name already exists. Cannot rename';
my $roleNameAlreadyExists    = 'Role with this name already exists. Cannot rename';

sub new
{
    my $self = shift;
    my $type = ref($self) || $self;
    $self = bless {}, $type;
    $self->{'OBJECTS'}    = \%objects;
    $self->{'FACTORY'}    = shift;
    $self->{'OPTFACTORY'} = shift;
    $self->{'ENV'}        = shift;
    # init filetemplate minimodule
    $self->{'FT'} = POS::Admin::GUI::FT->new($self->{'FACTORY'}, $self->{'OPTFACTORY'}, $self->{'ENV'});
    return $self;
} ## end sub new
## what needs to contain:

sub initData
{
    my ($self, $data) = @_;
    $self->{'DATA'} = $data;
    #here we store intermediate data for services, nics and roles
    $self->{'LISTS'} = { SERVICES => {}, NICS => {}, ROLES => {} };
    #set defaults
    #parse imported and update internal data structures
    my $bsinfo = {};
    my $bslist = $self->{'DATA'}->getBranchServerList();
    if (scalar @$bslist) {
        $bsinfo = $self->{'DATA'}->getBranchServer($bslist->[0]);
    }
    else {
        $bsinfo = $self->{'DATA'}->getBranchServer();
        $bslist = $self->{'DATA'}->getBranchServerList();
    }
    $self->{'BRANCHDN'} = $bslist->[0];

    $self->setValue(qw(EDIT_ORG), $bsinfo->{'organization'});
    $self->setValue(qw(EDIT_C),   $bsinfo->{'country'});
    $self->setValue(qw(EDIT_OU),  $bsinfo->{'organizationalUnit'});
    my $loc = $bsinfo->{'LOCATION'};
    $self->setValue(qw(EDIT_LOC),         $loc->{'scLocation'});
    $self->setValue(qw(EDIT_HOST),        $loc->{'scBranchServer'});
    $self->setValue(qw(EDIT_NET),         $loc->{'ipNetworkNumber'});
    $self->setValue(qw(EDIT_NET_MASK),    $loc->{'ipNetmaskNumber'});
    $self->setValue(qw(EDIT_PASS),        $loc->{'userPassword'});
    $self->setValue(qw(EDIT_PASS2),       $loc->{'userPassword'});
    $self->setValue(qw(EDIT_IP_MAP),      $loc->{'scIpMapFunc'});
    $self->setValue(qw(EDIT_DNS_MAP),     $loc->{'scDnsMapFunc'});
    $self->setValue(qw(EDIT_GATEWAY),     $loc->{'scDefaultGw'});
    $self->setValue(qw(EDIT_ENUMMASK),    $loc->{'scEnumerationMask'});
    $self->setValue(qw(EDIT_WSBASE),      $loc->{'scWorkstationBaseName'});
    $self->setValue(qw(EDIT_ASSOCDOMAIN), $loc->{'associatedDomain'});
    $self->setValue(qw(CHCK_EXDHCP),      $loc->{'scDhcpExtern'});
    $self->setValue(qw(EDIT_DHCP),        $loc->{'scDhcpRange'});
    $self->setValue(qw(EDIT_DHCP_FIXED),  $loc->{'scDhcpFixedRange'});
    $self->setValue(qw(EDIT_CONTAINER),   $bsinfo->{'scServerContainer'});
    ## store NICS
    my $nics = [$self->{'OBJECTS'}{SEL_NICS_NEW}{'LABEL'}];
    # store default
    $self->{'LISTS'}{NICS}{ $self->{'OBJECTS'}{SEL_NICS_NEW}{'LABEL'} } = { IPADDR => '' };
    # store imported
    foreach (keys %{ $bsinfo->{'NICS'} }) {
        # add to LIST_NICS
        $self->{'LISTS'}{NICS}{$_} = { IPADDR => $bsinfo->{'NICS'}{$_}{'ipHostNumber'} };
        push @$nics, $_;
    }
    # update sel list
    $self->setValue(qw(SEL_NICS), $nics);
    ## store SERVICES
    my $services = [$self->{'OBJECTS'}{SEL_SERVICE_NEW}{'LABEL'}];
    $self->{'LISTS'}{SERVICES}{ $self->{'OBJECTS'}{SEL_SERVICE_NEW}{'LABEL'} } =
      { DNSNAME => '', SCRIPT => '', ENABLED => 1 };
    foreach my $serviceName (keys %{ $bsinfo->{'SERVICES'} }) {
        my $service = { PARAMS => '' };
        foreach (keys %{ $bsinfo->{'SERVICES'}{$serviceName} }) {
            if ($_ eq 'scDnsName') {
                $service->{'DNSNAME'} = $bsinfo->{'SERVICES'}{$serviceName}{'scDnsName'};
            }
            elsif ($_ eq 'scServiceStartScript') {
                $service->{'SCRIPT'} = $bsinfo->{'SERVICES'}{$serviceName}{'scServiceStartScript'};
            }
            elsif ($_ eq 'scServiceStatus') {
                $service->{'ENABLED'} = $bsinfo->{'SERVICES'}{$serviceName}{'scServiceStatus'} eq 'TRUE' ? 1 : 0;
            }
            elsif ($_ eq 'scServiceName') {
                next;
            }
            else {
                $service->{'PARAMS'} = $service->{'PARAMS'} . "$_=" . $bsinfo->{'SERVICES'}{$serviceName}{$_} . "\n";
            }
        }
        $self->{'LISTS'}{SERVICES}{$serviceName} = $service;
        push @$services, $serviceName;
    }
    $self->setValue(qw(SEL_SERVICE), $services);
    ## store ROLES
    my ($enableLocal, $enableGlobal);
    my $roles = [$self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'}];
    $self->{'LISTS'}{ROLES}{ $self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'} } = { ROLE => 'global', TEMPLATES => {} };
    foreach (keys %{ $bsinfo->{'ROLES'} }) {
        my $role = $bsinfo->{'ROLES'}{$_};
        $self->{'LISTS'}{ROLES}{ $role->{'scRoleName'} } = $role;
        if ($role->{'ROLE'} eq 'global') {
            $enableGlobal = 1;
        }
        else {
            $enableLocal = 1;
        }
        push @$roles, $role->{'scRoleName'};
    }
    $self->setValue(qw(SEL_ROLES),   $roles);
    $self->setValue(qw(EDIT_IDLIST), $loc->{'scIdPool'});
    # enable roles if {LISTS}{ROLES} are not empty
    $self->setValue(qw(CHCK_GROLES), $enableGlobal);
    $self->setValue(qw(CHCK_LROLES), $enableLocal);

    $self->{'FT'}->initData($data);
} ## end sub initData

sub drawGUI
{
    my ($self, $parent) = @_;
    # undef all widget values - needed for value autosave
    foreach (keys %{ $self->{'OBJECTS'} }) {
        undef $self->{'OBJECTS'}{$_}{'WIDGET'};
    }
    # draw state
    if ($self->{'ENV'}{STATE} eq 'BS') {
        $self->drawBsBasicConfig($parent);
    }
    elsif ($self->{'ENV'}{STATE} eq 'BSnet') {
        $self->drawBsNetConfig($parent);
    }
    elsif ($self->{'ENV'}{STATE} eq 'BSservices') {
        $self->drawBsServices($parent);
    }
    elsif ($self->{'ENV'}{STATE} eq 'BSroles') {
        $self->drawBsRoles($parent);
    }
    elsif ($self->{'ENV'}{STATE} eq 'BSrolesft') {
        $self->{'FT'}->drawGUI($parent);
    }
} ## end sub drawGUI

sub drawBsBasicConfig
{
    my ($self, $replacePoint) = @_;
    my $factory = $self->{'FACTORY'};
    #basic layout
    my $frameBox = $factory->createVBox($replacePoint);
    my $DNbox = $self->createFrame($frameBox, qw(GLOBAL));
    $DNbox = $factory->createVBox($DNbox);
    #edits & labels
    # org and country to one line
    {
        my $tmpBox = $factory->createHBox($DNbox);
        my $editO = $self->createInputField($tmpBox, qw(EDIT_ORG));
        $editO->setValidChars($editDNValidChars);
        $editO->setWeight($yui::YD_HORIZ, 3);
        $factory->createHSpacing($tmpBox);
        my $editC = $self->createInputField($tmpBox, qw(EDIT_C));
        $editC->setValidChars($editCValidChars);
        $editC->setWeight($yui::YD_HORIZ, 1);
        $editC->setInputMaxLength(2);
        $factory->createHStretch($tmpBox)->setWeight($yui::YD_HORIZ, 2);
    }
    #delete old objects
    my @editOUs = ();
    my $first   = 1;
    foreach (@{ $self->getValue(qw(EDIT_OU)) }) {
        if ($first) {
            my $tmpBox = $factory->createHBox($DNbox);
            my $tmp = $self->createInputField($tmpBox, qw(EDIT_OU));
            $tmp->setValidChars($editDNValidChars);
            $tmp->setWeight($yui::YD_HORIZ, 3);
            push @editOUs, $tmp;
            $factory->createHSpacing($tmpBox);
            my $btnAddOU = $self->createPushButton($tmpBox, qw(BTN_NOU));
            $btnAddOU->setWeight($yui::YD_HORIZ, 1);
            $factory->createHStretch($tmpBox)->setWeight($yui::YD_HORIZ, 2);
            $first = 0;
        }
        else {
            my $tmpBox = $factory->createHBox($DNbox);
            my $tmp = $self->createInputField($tmpBox, qw(EDIT_OU));
            $tmp->setValidChars($editDNValidChars);
            $tmp->setWeight($yui::YD_HORIZ, 3);
            push @editOUs, $tmp;
            $factory->createHSpacing($tmpBox);
            $factory->createHStretch($tmpBox)->setWeight($yui::YD_HORIZ, 3);
        }
    }
    #update objects, OUS actually an array, createInputField always replace WIDGET
    $self->{'OBJECTS'}{EDIT_OU}{'WIDGET'} = \@editOUs;
    $self->updateWidgetValue(qw(EDIT_OU));
    # location
    {
        my $tmpBox = $factory->createHBox($DNbox);
        my $editL = $self->createInputField($tmpBox, qw(EDIT_LOC));
        $editL->setValidChars($editDNValidChars);
        $editL->setWeight($yui::YD_HORIZ, 3);
        $factory->createHSpacing($tmpBox);
        $factory->createHStretch($tmpBox)->setWeight($yui::YD_HORIZ, 3);
    }
    # password
    {
        my $tmpBox = $factory->createHBox($DNbox);
        my $editBSPass = $self->createPasswordField($tmpBox, qw(EDIT_PASS));
        $editBSPass->setWeight($yui::YD_HORIZ, 3);
        $editBSPass = $self->createPasswordField($tmpBox, qw(EDIT_PASS2));
        $editBSPass->setWeight($yui::YD_HORIZ, 3);
        $factory->createHSpacing($tmpBox);
        $factory->createHStretch($tmpBox)->setWeight($yui::YD_HORIZ, 3);
    }
    # BS details
    my $detailBox = $self->createFrame($frameBox, qw(DETAILS));
    $detailBox = $factory->createVBox($detailBox);
    my $netDetails = $factory->createHBox($detailBox);
    my $tmp        = $factory->createHBox($detailBox);
    # chBoxes
    my $chBoxes = $factory->createHBox($detailBox);
    $factory->createHSpacing($chBoxes);
    $self->createCheckBox($chBoxes, qw(CHCK_EXDHCP));
    $factory->createHSpacing($chBoxes);
    my $checkGlobalRoles = $self->createCheckBox($chBoxes, qw(CHCK_GROLES));
    $checkGlobalRoles->setNotify();
    $factory->createHSpacing($chBoxes);
    my $checkRoles = $self->createCheckBox($chBoxes, qw(CHCK_LROLES));
    $checkRoles->setNotify();
    $factory->createHSpacing($chBoxes);
    my $btnBsRoles = $self->createPushButton($chBoxes, qw(BTN_ROLES));

    if (not($self->getValue(qw(CHCK_GROLES)) or $self->getValue(qw(CHCK_LROLES)))) {
        $btnBsRoles->setEnabled(0);
    }
    else {
        $btnBsRoles->setEnabled(1);
    }
    $factory->createHStretch($chBoxes);
    # map functions
    if ($self->{'ENV'}{ADVANCED}) {
        my $advanced = $self->createFrame($frameBox, qw(ADVANCED));
        # id list
        $advanced = $factory->createVBox($advanced);
        my $idlist = $self->createInputField($advanced, qw(EDIT_IDLIST));
        $idlist->setStretchable($yui::YD_HORIZ, 1);
        $idlist->setValidChars('abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-;');
        # map functions (ip, dns)
        my $mapFuncs = $factory->createHBox($advanced);
        my $editIPfunc = $self->createInputField($mapFuncs, qw(EDIT_IP_MAP));
        $editIPfunc->setWeight($yui::YD_HORIZ, 3);
        $factory->createHSpacing($mapFuncs);
        my $editDNSfunc = $self->createInputField($mapFuncs, qw(EDIT_DNS_MAP));
        $editDNSfunc->setWeight($yui::YD_HORIZ, 3);
        $factory->createHSpacing($mapFuncs);
        my $editAssociatedDomain = $self->createInputField($mapFuncs, qw(EDIT_ASSOCDOMAIN));
        $editAssociatedDomain->setWeight($yui::YD_HORIZ, 3);
        my $names = $factory->createHBox($advanced);
        my $editEnumerationMask = $self->createInputField($names, qw(EDIT_ENUMMASK));
        $editEnumerationMask->setWeight($yui::YD_HORIZ, 3);
        $factory->createHSpacing($names);
        my $editWorkstationBaseName = $self->createInputField($names, qw(EDIT_WSBASE));
        $editWorkstationBaseName->setWeight($yui::YD_HORIZ, 3);
        $factory->createHSpacing($names);
        my $editContainer = $self->createInputField($names, qw(EDIT_CONTAINER));
        $editContainer->setWeight($yui::YD_HORIZ, 3);
    }
    my $buttons = $factory->createHBox($frameBox);
    my $btnBsServices = $self->createPushButton($buttons, qw(BTN_ADV));
    $factory->createHSpacing($buttons);
    my $btnBsNetConfig = $self->createPushButton($buttons, qw(BTN_NET));
    $factory->createHSpacing($buttons);
} ## end sub drawBsBasicConfig

sub drawBsNetConfig
{
    my ($self, $replacePoint) = @_;
    my $factory = $self->{'FACTORY'};
    #frame general
    my $vbox = $factory->createVBox($replacePoint);
    my $details = $self->createFrame($vbox, qw(FRAME_NETDETAILS));
    $details = $factory->createVBox($details);
    my $tmp = $factory->createHBox($details);
    my $editBSname = $self->createInputField($tmp, qw(EDIT_HOST));
    $editBSname->setWeight($yui::YD_HORIZ, 2);
    $editBSname->setValidChars($editDNValidChars);
    my $editSubnet = $self->createInputField($tmp, qw(EDIT_NET));
    $editSubnet->setWeight($yui::YD_HORIZ, 2);
    $editSubnet->setValidChars('0123456789.');
    $editSubnet->setInputMaxLength(15);
    my $editSubnetMask = $self->createInputField($tmp, qw(EDIT_NET_MASK));
    $editSubnetMask->setValidChars('0123456789.');
    $editSubnetMask->setInputMaxLength(15);
    $factory->createHStretch($tmp);
    $tmp = $factory->createHBox($details);
    my $editGateway = $self->createInputField($tmp, qw(EDIT_GATEWAY));
    $editGateway->setValidChars('0123456789.');
    $editGateway->setInputMaxLength(15);
    my $editBsDhcpFixedRange = $self->createInputField($tmp, qw(EDIT_DHCP_FIXED));
    $editBsDhcpFixedRange->setValidChars('0123456789.,');
    $editBsDhcpFixedRange->setInputMaxLength(31);
    my $editBsDhcpRange = $self->createInputField($tmp, qw(EDIT_DHCP));
    $editBsDhcpRange->setValidChars('0123456789.,');
    $editBsDhcpRange->setInputMaxLength(31);
    $factory->createHStretch($tmp);
    #frame NIC settings
    my $nics = $self->createFrame($vbox, qw(FRAME_NETNICS));
    $nics = $factory->createHBox($nics);
    $self->createSelectionBox($nics, qw(SEL_NICS))->setWeight($yui::YD_HORIZ, 3);
    $tmp = $factory->createVBox($nics);
    $tmp->setWeight($yui::YD_HORIZ, 4);
    $self->createInputField($tmp, qw(EDIT_NIC_NAME))->setStretchable($yui::YD_HORIZ, 1);
    $self->createInputField($tmp, qw(EDIT_NIC_IPADDR))->setStretchable($yui::YD_HORIZ, 1);
    $self->createPushButton($tmp, qw(BTN_NIC_ADD))->setStretchable($yui::YD_HORIZ, 1);
    $self->createPushButton($tmp, qw(BTN_NIC_DEL))->setStretchable($yui::YD_HORIZ, 1);
    $factory->createVStretch($tmp);
    $factory->createHSpacing($nics)->setWeight($yui::YD_HORIZ, 3);
    #button save/cancel
    $self->createPushButton($vbox, qw(BTN_SAVE));
    $factory->createVStretch($vbox);
} ## end sub drawBsNetConfig

sub drawBsServices
{
    my ($self, $replacePoint) = @_;
    my $factory = $self->{'FACTORY'};
    #frame general
    my $vbox = $factory->createVBox($replacePoint);
    # sel list pro services
    my $servs = $self->createFrame($vbox, qw(FRAME_SERVICE));
    $servs = $factory->createHBox($servs);
    $self->createSelectionBox($servs, qw(SEL_SERVICE))->setWeight($yui::YD_HORIZ, 3);
    my $tmp = $factory->createVBox($servs);
    $tmp->setWeight($yui::YD_HORIZ, 4);
    $self->createInputField($tmp, qw(EDIT_SERVICE_NAME))->setStretchable($yui::YD_HORIZ, 1);
    $self->createInputField($tmp, qw(EDIT_SERVICE_DNS))->setStretchable($yui::YD_HORIZ, 1);
    $self->createInputField($tmp, qw(EDIT_SERVICE_SCRIPT))->setStretchable($yui::YD_HORIZ, 1);
    #multiline edit for service specific configuration
    $self->createMultilineEdit($tmp, qw(EDIT_SERVICE_PARAMS))->setStretchable($yui::YD_HORIZ, 1);
    $self->createCheckBox($tmp, qw(CHCK_SERVICE_ENABLED));
    $self->createPushButton($tmp, qw(BTN_SERVICE_ADD))->setStretchable($yui::YD_HORIZ, 1);
    $self->createPushButton($tmp, qw(BTN_SERVICE_DEL))->setStretchable($yui::YD_HORIZ, 1);
    $factory->createVStretch($tmp);
    $factory->createHSpacing($servs)->setWeight($yui::YD_HORIZ, 3);
    #button save/cancel
    $self->createPushButton($vbox, qw(BTN_SAVE));
    $factory->createVStretch($vbox);
} ## end sub drawBsServices

sub drawBsRoles
{
    my ($self, $replacePoint) = @_;
    my $factory = $self->{'FACTORY'};
    my $vbox    = $factory->createVBox($replacePoint);
    my $frame   = $self->createFrame($vbox, qw(FRAME_ROLES));
    $frame = $factory->createHBox($frame);
    #sel list pro roles
    $self->createSelectionBox($frame, qw(SEL_ROLES))->setWeight($yui::YD_HORIZ, 3);
    my $tmp = $factory->createVBox($frame);
    $factory->createHSpacing($frame)->setWeight($yui::YD_HORIZ, 2);
    $tmp->setWeight($yui::YD_HORIZ, 4);
    $factory->createVSpacing($tmp);
    #radio local/global
    my $radios = $factory->createRadioButtonGroup($tmp);
    $radios = $factory->createHBox($radios);
    $self->createRadioButton($radios, qw(RADIO_ROLE_GLOBAL));
    $factory->createHSpacing($radios);
    $self->createRadioButton($radios, qw(RADIO_ROLE_LOCAL));
    #edit role name
    $self->createInputField($tmp, qw(EDIT_ROLE_NAME))->setStretchable(0, 1);
    #FT list
    $self->{'FT'}->drawEmbedded($tmp);
    #button add/update/remove role
    my $buttons = $factory->createHBox($tmp);
    $self->createPushButton($buttons, qw(BTN_ROLE_ADD))->setStretchable($yui::YD_HORIZ, 1);
    $self->createPushButton($buttons, qw(BTN_ROLE_DEL))->setStretchable($yui::YD_HORIZ, 1);
    $factory->createVStretch($tmp);
    #button na return
    my $returnButton = $self->createPushButton($vbox, qw(BTN_SAVE));
    $factory->createVStretch($vbox);
    $self->selectRole($self->getValue(qw(EDIT_ROLE_NAME)));
} ## end sub drawBsRoles


# transer data from widgets cache to internal XML
sub storeData
{
    my ($self, $data) = @_;
    # store values from widget to internal struct
    $self->storeAllWidgetValue() if ($self->{'ENV'}{'STATE'} =~ /BS/);
    # check password match
    if ($self->getValue(qw(EDIT_PASS)) ne $self->getValue(qw(EDIT_PASS2))) {
        $self->okPopup('BranchServer passwords does not match!');
        return;
    }
    # store basics
    my $bsinfo = {
        organization       => $self->getValue(qw(EDIT_ORG)),
        country            => $self->getValue(qw(EDIT_C)),
        organizationalUnit => $self->getValue(qw(EDIT_OU))
    };
    $bsinfo->{'scLocation'}     = $self->getValue(qw(EDIT_LOC));
    $bsinfo->{'scBranchServer'} = $self->getValue(qw(EDIT_HOST));
    $bsinfo->{'LOCATION'}       = {
        ipNetworkNumber       => $self->getValue(qw(EDIT_NET)),
        ipNetmaskNumber       => $self->getValue(qw(EDIT_NET_MASK)),
        userPassword          => $self->getValue(qw(EDIT_PASS)),
        scIpMapFunc           => $self->getValue(qw(EDIT_IP_MAP)),
        scDnsMapFunc          => $self->getValue(qw(EDIT_DNS_MAP)),
        scDefaultGw           => $self->getValue(qw(EDIT_GATEWAY)),
        scEnumerationMask     => $self->getValue(qw(EDIT_ENUMMASK)),
        scWorkstationBaseName => $self->getValue(qw(EDIT_WSBASE)),
        associatedDomain      => $self->getValue(qw(EDIT_ASSOCDOMAIN)),
        scAllowRoles          => $self->getValue(qw(CHCK_LROLES)) ? 'TRUE' : 'FALSE',
        scAllowGlobalRoles    => $self->getValue(qw(CHCK_GROLES)) ? 'TRUE' : 'FALSE',
        scDhcpExtern          => $self->getValue(qw(CHCK_EXDHCP)) ? 'TRUE' : 'FALSE',
        scDynamicIp           => 'TRUE',
        scDhcpRange           => $self->getValue(qw(EDIT_DHCP)),
        scDhcpFixedRange      => $self->getValue(qw(EDIT_DHCP_FIXED)),
        scIdPool              => $self->getValue(qw(EDIT_IDLIST))
    };
    $bsinfo->{'scServerContainer'} = $self->getValue(qw(EDIT_CONTAINER));
    # store NICS
    foreach (keys %{ $self->{'LISTS'}{NICS} }) {
        next if ($_ eq $self->{'OBJECTS'}{SEL_NICS_NEW}{'LABEL'});
        $bsinfo->{'NICS'}{$_} = { ipHostNumber => $self->{'LISTS'}{NICS}{$_}{'IPADDR'} };
    }
    # store SERVICES
    foreach my $service (keys %{ $self->{'LISTS'}{SERVICES} }) {
        next if ($service eq $self->{'OBJECTS'}{SEL_SERVICE_NEW}{'LABEL'});
        $bsinfo->{'SERVICES'}{$service} = {
            scDnsName            => $self->{'LISTS'}{SERVICES}{$service}{'DNSNAME'},
            scServiceName        => $service,
            scServiceStatus      => $self->{'LISTS'}{SERVICES}{$service}{'ENABLED'} ? 'TRUE' : 'FALSE',
            scServiceStartScript => $self->{'LISTS'}{SERVICES}{$service}{'SCRIPT'}
        };
        #parse multiline
        my @params = split(/\n/, $self->{'LISTS'}{SERVICES}{$service}{'PARAMS'});
        foreach (@params) {
            my ($option, $value) = split(/=/, $_);
            $bsinfo->{'SERVICES'}{$service}{$option} = $value;
        }
    }
    # store ROLES
    foreach (keys %{ $self->{'LISTS'}{ROLES} }) {
        next if ($_ eq $self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'});
        $bsinfo->{'ROLES'}{$_} = $self->{'LISTS'}{ROLES}{$_};
        $bsinfo->{'ROLES'}{$_}{'scRoleName'} = $_;
    }
    $data->updateBranchServer($bsinfo, $self->{'BRANCHDN'});
    return 1;
} ## end sub storeData

######################################
## selectors
##################
sub selectService
{
    my ($self, $name) = @_;
    if ((not defined $name) or ($name eq $self->{'OBJECTS'}{SEL_SERVICE_NEW}{'LABEL'})) {
        $name = $self->{'OBJECTS'}{SEL_SERVICE_NEW}{'LABEL'};
        $self->setValue(qw(EDIT_SERVICE_NAME), '');
        $self->getWidget(qw(BTN_SERVICE_ADD))->setLabel($self->{'OBJECTS'}{BTN_SERVICE_ADD}{'LABEL'});
    }
    else {
        $self->setValue(qw(EDIT_SERVICE_NAME), $name);
        $self->getWidget(qw(BTN_SERVICE_ADD))->setLabel($self->{'OBJECTS'}{BTN_SERVICE_ADD}{'LABEL1'});
    }
    $self->setValue(qw(EDIT_SERVICE_DNS),     $self->{'LISTS'}{SERVICES}{$name}{'DNSNAME'});
    $self->setValue(qw(EDIT_SERVICE_SCRIPT),  $self->{'LISTS'}{SERVICES}{$name}{'SCRIPT'});
    $self->setValue(qw(CHCK_SERVICE_ENABLED), $self->{'LISTS'}{SERVICES}{$name}{'ENABLED'});
    $self->setValue(qw(EDIT_SERVICE_PARAMS),  $self->{'LISTS'}{SERVICES}{$name}{'PARAMS'});

    $self->updateAllWidgetValue();
    my $selBox = $self->getWidget(qw(SEL_SERVICE));
    $selBox->selectItem($selBox->findItem($name));
} ## end sub selectService

sub selectNIC
{
    my ($self, $name) = @_;
    if ((not defined $name) or ($name eq $self->{'OBJECTS'}{SEL_NICS_NEW}{'LABEL'})) {
        $name = $self->{'OBJECTS'}{SEL_NICS_NEW}{'LABEL'};
        $self->setValue(qw(EDIT_NIC_NAME), '');
        $self->getWidget(qw(BTN_NIC_ADD))->setLabel($self->{'OBJECTS'}{BTN_NIC_ADD}{'LABEL'});
    }
    else {
        $self->setValue(qw(EDIT_NIC_NAME), $name);
        $self->getWidget(qw(BTN_NIC_ADD))->setLabel($self->{'OBJECTS'}{BTN_NIC_ADD}{'LABEL1'});
    }
    $self->setValue(qw(EDIT_NIC_IPADDR), $self->{'LISTS'}{NICS}{$name}{'IPADDR'});

    $self->updateAllWidgetValue();
    my $selBox = $self->getWidget(qw(SEL_NICS));
    $selBox->selectItem($selBox->findItem($name));
} ## end sub selectNIC

sub selectRole
{
    my ($self, $name) = @_;
    if ((not $name) or ($name eq $self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'})) {
        $name = $self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'};
        $self->setValue(qw(EDIT_ROLE_NAME), '');
        $self->getWidget(qw(BTN_ROLE_ADD))->setLabel($self->{'OBJECTS'}{BTN_ROLE_ADD}{'LABEL'});
    }
    else {
        $self->setValue(qw(EDIT_ROLE_NAME), $name);
        $self->getWidget(qw(BTN_ROLE_ADD))->setLabel($self->{'OBJECTS'}{BTN_ROLE_ADD}{'LABEL1'});
    }
    if (not $self->getWidget(qw(SEL_ROLES))->findItem($name)) {
        #role is in process being added, load <new role> data
        $name = $self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'};
    }
    if ($self->{'LISTS'}{ROLES}{$name}{'ROLE'} eq 'local') {
        $self->setValue(qw(RADIO_ROLE_LOCAL),  1);
        $self->setValue(qw(RADIO_ROLE_GLOBAL), 0);
    }
    else {
        $self->setValue(qw(RADIO_ROLE_GLOBAL), 1);
        $self->setValue(qw(RADIO_ROLE_LOCAL),  0);
    }
    $self->updateAllWidgetValue();
    $self->{'FT'}->updateData($self->{'LISTS'}{ROLES}{$name}{'TEMPLATES'});
    my $selBox = $self->getWidget(qw(SEL_ROLES));
    $selBox->selectItem($selBox->findItem($name));
} ## end sub selectRole
######################################
## EOF selectors
##################
sub processEvent
{
    my ($self, $event) = @_;
    my $widget = $event->widget();
    $self->storeAllWidgetValue();
    ## state BS
    if ($self->{'ENV'}{STATE} eq 'BS') {
        if ($widget == $self->{'OBJECTS'}{BTN_ADV}{'WIDGET'}) {
            $self->{'ENV'}{STATE} = 'BSservices';
        }
        elsif ($widget == $self->{'OBJECTS'}{CHCK_GROLES}{'WIDGET'} or
            $widget == $self->{'OBJECTS'}{CHCK_LROLES}{'WIDGET'}) {
            if ($self->getWidgetValue(qw(CHCK_GROLES)) or $self->getWidgetValue(qw(CHCK_LROLES))) {
                $self->getWidget(qw(BTN_ROLES))->setEnabled(1);
            }
            else {
                $self->getWidget(qw(BTN_ROLES))->setEnabled(0);
            }
        }
        elsif ($widget == $self->{'OBJECTS'}{BTN_NET}{'WIDGET'}) {
            $self->{'ENV'}{STATE} = 'BSnet';
        }
        elsif ($widget == $self->{'OBJECTS'}{BTN_ROLES}{'WIDGET'}) {
            $self->{'ENV'}{STATE} = 'BSroles';
        }
        elsif ($widget == $self->{'OBJECTS'}{BTN_NOU}{'WIDGET'}) {
            my $ous = $self->getValue(qw(EDIT_OU));
            push @$ous, '';
            $self->setValue(qw(EDIT_OU), $ous);
            return 1;
        }
    }
    elsif ($widget == $self->{'OBJECTS'}{BTN_SAVE}{'WIDGET'}) {
        $self->{'ENV'}{STATE} = 'BS';
    }
    ########## state BSservices #####################################################################
    elsif ($self->{'ENV'}{STATE} eq 'BSservices') {
        if ($widget == $self->{'OBJECTS'}{BTN_SERVICE_ADD}{'WIDGET'}) {
            # add new service to SELLIST, select it, store data to internal datastruct
            my $selBox = $self->getWidget(qw(SEL_SERVICE));
            # get selected item in selection widget
            my $selectedItem = $selBox->selectedItem();
            # get name filled in service name input
            my $serviceName = $self->getWidgetValue(qw(EDIT_SERVICE_NAME));
            #check name
            return if (not $serviceName);
            if (defined $selectedItem && $selectedItem->label() ne $objects{'SEL_SERVICE_NEW'}{LABEL}) {
                if ($selectedItem->label() ne $serviceName) {
                    #name changed, check uniqueness
                    if (defined $self->{'LISTS'}{SERVICES}{$serviceName}) {
                        $self->okPopup($serviceNameAlreadyExists);
                        next;
                    }
                    #rename, delete old name
                    delete $self->{'LISTS'}{SERVICES}{ $selectedItem->label() };
                    my $list = $self->getValue(qw(SEL_SERVICE));
                    for (my $i = 0; $i < scalar @$list; $i++) {
                        if ($list->[$i] eq $selectedItem->label()) {
                            $list->[$i] = $serviceName;
                            last;
                        }
                    }
                    $self->setValue(qw(SEL_SERVICE), $list);
                }
            }
            else {
                # adding new
                #check if unique
                if (defined $self->{'LISTS'}{SERVICES}{$serviceName}) {
                    $self->okPopup($serviceNameAlreadyExists);
                    next;
                }
                my $list = $self->getValue(qw(SEL_SERVICE));
                push @$list, $serviceName;
                $self->setValue(qw(SEL_SERVICE), $list);
            }
            # add new data (when either adding new or renaming)
            $self->{'LISTS'}{SERVICES}{$serviceName} = {
                DNSNAME => $self->getWidgetValue(qw(EDIT_SERVICE_DNS)),
                SCRIPT  => $self->getWidgetValue(qw(EDIT_SERVICE_SCRIPT)),
                ENABLED => $self->getWidgetValue(qw(CHCK_SERVICE_ENABLED)),
                PARAMS  => $self->getWidgetValue(qw(EDIT_SERVICE_PARAMS))
            };
            # update selList
            $self->updateSelectionWidgetValue(qw(SEL_SERVICE));
            $self->selectService($serviceName);
        }
        elsif ($widget == $self->{'OBJECTS'}{BTN_SERVICE_DEL}{'WIDGET'}) {
            # del service from SELLIST, select <new>, remove data from internal datastruct
            my $selBox = $self->getWidget(qw(SEL_SERVICE));
            # get selected item in selection widget
            my $selectedItem = $selBox->selectedItem();
            if (defined $selectedItem && $selectedItem->label() ne $objects{'SEL_SERVICE_NEW'}{LABEL}) {
                delete $self->{'LISTS'}{SERVICES}{ $selectedItem->label() };
                my $list    = $self->getValue(qw(SEL_SERVICE));
                my $newlist = [];
                for (my $i = 0; $i < scalar @$list; $i++) {
                    if ($list->[$i] ne $selectedItem->label()) {
                        push @$newlist, $list->[$i];
                    }
                }
                $self->setValue(qw(SEL_SERVICE), $newlist);
                $self->selectService();
            }
        }
        elsif ($widget == $self->{'OBJECTS'}{SEL_SERVICE}{'WIDGET'}) {
            my $name = $self->getWidget(qw(SEL_SERVICE))->selectedItem()->label();
            $self->selectService($name);
        }
    }
    ########### state BSnet #########################################################################
    elsif ($self->{'ENV'}{STATE} eq 'BSnet') {
        if ($widget == $self->{'OBJECTS'}{BTN_NIC_ADD}{'WIDGET'}) {
            # add new service to SELLIST, select it, store data to internal datastruct
            my $selBox = $self->getWidget(qw(SEL_NICS));
            # get selected item in selection widget
            my $selectedItem = $selBox->selectedItem();
            # get name filled in service name input
            my $nicName = $self->getWidgetValue(qw(EDIT_NIC_NAME));
            #check name
            return if (not $nicName);
            if (defined $selectedItem && $selectedItem->label() ne $objects{'SEL_NICS_NEW'}{LABEL}) {
                if ($selectedItem->label() ne $nicName) {
                    #name changed, check uniqueness
                    if (defined $self->{'LISTS'}{NICS}{$nicName}) {
                        $self->okPopup($nicNameAlreadyExists);
                        next;
                    }
                    #rename, delete old name
                    delete $self->{'LISTS'}{NICS}{ $selectedItem->label() };
                    my $list = $self->getValue(qw(SEL_NICS));
                    for (my $i = 0; $i < scalar @$list; $i++) {
                        if ($list->[$i] eq $selectedItem->label()) {
                            $list->[$i] = $nicName;
                            last;
                        }
                    }
                    $self->setValue(qw(SEL_NICS), $list);
                }
            }
            else {
                # adding new
                #check if unique
                if (defined $self->{'LISTS'}{NICS}{$nicName}) {
                    $self->okPopup($nicNameAlreadyExists);
                    next;
                }
                my $list = $self->getValue(qw(SEL_NICS));
                push @$list, $nicName;
                $self->setValue(qw(SEL_NICS), $list);

            }
            # add new data (when either adding new or renaming)
            $self->{'LISTS'}{NICS}{$nicName} = { IPADDR => $self->getWidgetValue(qw(EDIT_NIC_IPADDR)), };
            # update selList
            $self->updateSelectionWidgetValue(qw(SEL_NICS));
            $self->selectNIC($nicName);
        }
        elsif ($widget == $self->{'OBJECTS'}{BTN_NIC_DEL}{'WIDGET'}) {
            my $selBox = $self->getWidget(qw(SEL_NICS));
            # get selected item in selection widget
            my $selectedItem = $selBox->selectedItem();
            if (defined $selectedItem && $selectedItem->label() ne $objects{'SEL_NICS_NEW'}{LABEL}) {
                delete $self->{'LISTS'}{NICS}{ $selectedItem->label() };
                my $list    = $self->getValue(qw(SEL_NICS));
                my $newlist = [];
                for (my $i = 0; $i < scalar @$list; $i++) {
                    if ($list->[$i] ne $selectedItem->label()) {
                        push @$newlist, $list->[$i];
                    }
                }
                $self->setValue(qw(SEL_NICS), $newlist);
                $self->selectNIC();
            }
        }
        elsif ($widget == $self->{'OBJECTS'}{SEL_NICS}{'WIDGET'}) {
            my $nicName = $self->getWidget(qw(SEL_NICS))->selectedItem()->label();
            $self->selectNIC($nicName);
        }
    }
    ########## state BSroles #######################################################################
    elsif ($self->{'ENV'}{STATE} eq 'BSroles') {
        if ($widget == $self->{'OBJECTS'}{BTN_ROLE_ADD}{'WIDGET'}) {
            # add new service to SELLIST, select it, store data to internal datastruct
            my $selBox = $self->getWidget(qw(SEL_ROLES));
            # get selected item in selection widget
            my $selectedItem = $selBox->selectedItem();
            # get name filled in service name input
            my $roleName = $self->getWidgetValue(qw(EDIT_ROLE_NAME));
            # check name
            return if (not $roleName);
            # templates tmpvar
            my $templates;
            if (defined $selectedItem && $selectedItem->label() ne $objects{'SEL_ROLES_NEW'}{LABEL}) {
                if ($selectedItem->label() ne $roleName) {
                    #name changed, check uniqueness
                    if (defined $self->{'LISTS'}{ROLES}{$roleName}) {
                        $self->okPopup($roleNameAlreadyExists);
                        next;
                    }
                    #preserve DN to track movement
                    $self->{'LISTS'}{ROLES}{$roleName}{'DN'} = $self->{'LISTS'}{ROLES}{ $selectedItem->label() }{'DN'};
                    #rename, delete old name
                    delete $self->{'LISTS'}{ROLES}{ $selectedItem->label() };
                    my $list = $self->getValue(qw(SEL_ROLES));
                    for (my $i = 0; $i < scalar @$list; $i++) {
                        if ($list->[$i] eq $selectedItem->label()) {
                            $list->[$i] = $roleName;
                            last;
                        }
                    }
                    $self->setValue(qw(SEL_ROLES), $list);
                }
                $templates = $self->{'LISTS'}{ROLES}{$roleName}{'TEMPLATES'};
            }
            else {
                # adding new
                #check if unique
                if (defined $self->{'LISTS'}{ROLES}{$roleName}) {
                    $self->okPopup($roleNameAlreadyExists);
                    next;
                }
                my $list = $self->getValue(qw(SEL_ROLES));
                push @$list, $roleName;
                $self->setValue(qw(SEL_ROLES), $list);
                $templates = $self->{'LISTS'}{ROLES}{ $self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'} }{'TEMPLATES'};
                $self->{'LISTS'}{ROLES}{ $self->{'OBJECTS'}{SEL_ROLES_NEW}{'LABEL'} }{'TEMPLATES'} = {};

            }
            # add new data (when either adding new or renaming)
            if ($self->getWidgetValue(qw(RADIO_ROLE_GLOBAL))) {
                $self->{'LISTS'}{ROLES}{$roleName}{'ROLE'} = 'global';
            }
            else {
                $self->{'LISTS'}{ROLES}{$roleName}{'ROLE'} = 'local';
            }
            $self->{'LISTS'}{ROLES}{$roleName}{'TEMPLATES'} = $templates;
            # update selList
            $self->updateSelectionWidgetValue(qw(SEL_ROLES));
            $self->selectRole($roleName);
        }
        elsif ($widget == $self->{'OBJECTS'}{BTN_ROLE_DEL}{'WIDGET'}) {
            my $selBox = $self->getWidget(qw(SEL_ROLES));
            # get selected item in selection widget
            my $selectedItem = $selBox->selectedItem();
            if (defined $selectedItem && $selectedItem->label() ne $objects{'SEL_ROLES_NEW'}{LABEL}) {
                delete $self->{'LISTS'}{ROLES}{ $selectedItem->label() };
                my $list    = $self->getValue(qw(SEL_ROLES));
                my $newlist = [];
                for (my $i = 0; $i < scalar @$list; $i++) {
                    if ($list->[$i] ne $selectedItem->label()) {
                        push @$newlist, $list->[$i];
                    }
                }
                $self->setValue(qw(SEL_ROLES), $newlist);
                $self->selectRole();
            }
        }
        elsif ($widget == $self->{'OBJECTS'}{SEL_ROLES}{'WIDGET'}) {
            my $roleName = $self->getWidget(qw(SEL_ROLES))->selectedItem()->label();
            $self->selectRole($roleName);
        }
        else {
            $self->{'FT'}->processEvent($event);
        }
    }
    elsif ($self->{'ENV'}{STATE} =~ /BS.*ft/) {
        # process only file templates events
        $self->{'FT'}->processEvent($event);
    }
    # no change
    return;
} ## end sub processEvent
